module RND_Animatex

	class Animatex
	
		@@model = Sketchup.active_model ;
		@@dir = File.dirname(__FILE__) # this plugin's folder
		@@path = File.join(@@dir, '/RND_Animatex/')
		@@rnd_animatex = "rnd_animatex.html" ;
		@@animatex_files = File.join(@@dir, '/RND_Animatex/AnimatexFiles/')
		@@animatex_dlg = nil ;

	
		
		def initialize()
		
			@animatex_1_file =  File.join(@@path, @@rnd_animatex) 
	   
			if (!@animatex_1_file) then 
				UI.messagebox("Cannot find file '#{@@rnd_animatex} in folder '#{@@path}'") ; 
				return ;
			end ; 
			
			if @@animatex_dlg == nil
				@@animatex_dlg = UI::WebDialog.new("RND_Animatex v.1.0.1", false, "RND_Animatex v.1.0.1", 250, 490, 70, 95, true) ;

				@@animatex_dlg.add_action_callback("push_frame") do |d,p| 
				push_frame(d,p) 
				end ;
			end ;
			
			@@animatex_dlg.set_size(250, 490) ;
			@@animatex_dlg.set_file(@animatex_1_file) ;
			@@animatex_dlg.show() ; 
			
			@texture = false ;
			@animate= false ;
			@speed_x = nil ;
			@speed_y = nil ;
			
			
			Sketchup.send_action('selectSelectionTool:') ; #Selection Tool
		end #def 
		
		
		
		def push_frame(dialog,data)
				
			params = query_to_hash(data) ;  # parse state information 
			
			if @animate
					
				model = Sketchup.active_model
				ents = model.entities 

				faces = []


				ents.each do |e|

					if e.is_a? Sketchup::Face
							faces << e 
					end
				end
				
				faces.each do |e|

					mat = e.material

					pt_array = []
					pt_array[0] = Geom::Point3d.new(@speed_x,@speed_y,0)
					pt_array[1] = Geom::Point3d.new(0,0,0)
					on_front = true
					
					e.position_material mat, pt_array, on_front
										  
				end 	

			end
				
			#Click Animate
			if params['active'].to_s == "1" 

				Sketchup.active_model.select_tool RND_Animatex::Animatex.new
			
				@speed_x = params['getx'].to_f 
				@speed_y = params['gety'].to_f 
				
	
				@texture = true
				@animate= true
				
				activate = 0
				script = "top.active = " + activate.to_s + ";"
				dialog.execute_script(script);	
				Sketchup.send_action('selectSelectionTool:') ; #Selection Tool
				
			end
			
			#Click Pause
			if params['pause'].to_s == "1" 	
			
				@animate= false
			
				paused = 0
				script = "top.pause = " + paused.to_s + ";"
				dialog.execute_script(script);
				Sketchup.send_action('selectSelectionTool:') ; #Selection Tool
				
			end
		
			#Click Done
			if params['done'].to_s == "1" 
				
				@animate= false
			
				Sketchup.send_action('selectSelectionTool:') ; #Selection Tool
				@@animatex_dlg.close ;	

			end
					
		end #def
		
		
		
		def unescape(string)
			if string != nil
				string = string.gsub(/\+/, ' ').gsub(/((?:%[0-9a-fA-F]{2})+)/n) do
					[$1.delete('%')].pack('H*')
				end
			end
			return string
		end #def
		
		
		
		def query_to_hash(query)
			param_pairs = query.split('&')
			param_hash = {}
			for param in param_pairs
				name, value = param.split('=')
				name = unescape(name)
				value = unescape(value)
				param_hash[name] = value
			end
			return param_hash
		end #def
		

		
	end #class
	
end #module

unless file_loaded?( File.basename(__FILE__) )
	$renderiza_menu.add_item('Animatex') { 
	Sketchup.active_model.select_tool RND_Animatex::Animatex.new
	}
	$renderiza_menu.add_separator
	# Add toolbar
	rnd_animatex_tb = UI::Toolbar.new "Animatex"
	rnd_animatex_cmd = UI::Command.new("Animatex") { 
	Sketchup.active_model.select_tool RND_Animatex::Animatex.new 
	} 
	rnd_animatex_cmd.small_icon = "RND_Animatex/img/rnd_animatex_1_16.png"
	rnd_animatex_cmd.large_icon = "RND_Animatex/img/rnd_animatex_1_24.png"
	rnd_animatex_cmd.tooltip = "Animatex - Animated Textures"
	rnd_animatex_cmd.menu_text = "Animatex"
	rnd_animatextb = rnd_animatex_tb.add_item rnd_animatex_cmd
	rnd_animatex_tb.show
   
end

file_loaded( File.basename(__FILE__) )   # Mark the script loaded. 